//+------------------------------------------------------------------+ 
//|                                              ColorZerolagRSI.mq5 | 
//|                               Copyright  2015, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
//----  
#property copyright "Copyright  2015, Nikolay Kositsin"
//----    
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.01"
//----     
#property indicator_separate_window
//----    2
#property indicator_buffers 4 
//----    
#property indicator_plots   3
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----       - 
#property indicator_color1 clrBlueViolet
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1 "FastTrendLine"
//----     
#property indicator_type2   DRAW_LINE
//----       - 
#property indicator_color2 clrBlueViolet
//----   -  
#property indicator_style2  STYLE_SOLID
//----     1
#property indicator_width2  1
//----   
#property indicator_label2 "SlowTrendLine"
//+-----------------------------------+
//|          |
//+-----------------------------------+
//----        
#property indicator_type3   DRAW_FILLING
//----       Aqua  Tomato 
#property indicator_color3  clrAqua,clrTomato
//----   
#property indicator_label3 "ZerolagRSI"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint    smoothing=15;
input ENUM_APPLIED_PRICE IPC=PRICE_CLOSE; //  
//----
input double Factor1=0.05;
input uint    RSI_period1=8;
//----
input double Factor2=0.10;
input uint    RSI_period2=21;
//----
input double Factor3=0.16;
input uint    RSI_period3=34;
//----
input double Factor4=0.26;
input int    RSI_period4=55;
//----
input double Factor5=0.43;
input uint    RSI_period5=89;
//+-----------------------------------+
//----      
int StartBar;
//----     
double smoothConst;
//----  
double FastBuffer[];
double SlowBuffer[];
double FastBuffer_[];
double SlowBuffer_[];
//----      
int RSI1_Handle,RSI2_Handle,RSI3_Handle,RSI4_Handle,RSI5_Handle;
//+------------------------------------------------------------------+    
//| ZerolagRSI indicator initialization function                     | 
//+------------------------------------------------------------------+  
int OnInit()
  {
//----  
   smoothConst=(smoothing-1.0)/smoothing;
//---- 
   uint PeriodBuffer[5];
//----   
   PeriodBuffer[0] = RSI_period1;
   PeriodBuffer[1] = RSI_period2;
   PeriodBuffer[2] = RSI_period3;
   PeriodBuffer[3] = RSI_period4;
   PeriodBuffer[4] = RSI_period5;
//----
   StartBar=int(3*PeriodBuffer[ArrayMaximum(PeriodBuffer,0,WHOLE_ARRAY)])+2;
//----    iRSI1
   RSI1_Handle=iRSI(NULL,0,RSI_period1,IPC);
   if(RSI1_Handle==INVALID_HANDLE)
     {
      Print("      iRSI1");
      return(INIT_FAILED);
     }
//----    iRSI2
   RSI2_Handle=iRSI(NULL,0,RSI_period2,IPC);
   if(RSI2_Handle==INVALID_HANDLE)
     {
      Print("      iRSI2");
      return(INIT_FAILED);
     }
//----    iRSI3
   RSI3_Handle=iRSI(NULL,0,RSI_period3,IPC);
   if(RSI3_Handle==INVALID_HANDLE)
     {
      Print("      iRSI3");
      return(INIT_FAILED);
     }
//----    iRSI4
   RSI4_Handle=iRSI(NULL,0,RSI_period4,IPC);
   if(RSI4_Handle==INVALID_HANDLE)
     {
      Print("      iRSI4");
      return(INIT_FAILED);
     }
//----    iRSI5
   RSI5_Handle=iRSI(NULL,0,RSI_period5,IPC);
   if(RSI5_Handle==INVALID_HANDLE)
     {
      Print("      iRSI5");
      return(INIT_FAILED);
     }
//----      
   SetIndexBuffer(0,FastBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBar);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"FastTrendLine");
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(FastBuffer,true);
//----
//----      
   SetIndexBuffer(1,SlowBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBar);
//---      DataWindow
   PlotIndexSetString(1,PLOT_LABEL,"SlowTrendLine");
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(SlowBuffer,true);
//----
//----      
   SetIndexBuffer(2,FastBuffer_,INDICATOR_DATA);
//----       
   ArraySetAsSeries(FastBuffer_,true);
//----
//----      
   SetIndexBuffer(3,SlowBuffer_,INDICATOR_DATA);
//----       
   ArraySetAsSeries(SlowBuffer_,true);
//----
//----       1
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,StartBar);
//---      DataWindow
   PlotIndexSetString(2,PLOT_LABEL,"FastTrendLine");
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----
//----      
   string shortname="ZerolagRSI";
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+  
//| ZerolagRSI iteration function                                    | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(RSI1_Handle)<rates_total
      || BarsCalculated(RSI2_Handle)<rates_total
      || BarsCalculated(RSI3_Handle)<rates_total
      || BarsCalculated(RSI4_Handle)<rates_total
      || BarsCalculated(RSI5_Handle)<rates_total
      || rates_total<StartBar)
      return(0);
//----       
   double Osc1,Osc2,Osc3,Osc4,Osc5,FastTrend,SlowTrend;
   double RSI1[],RSI2[],RSI3[],RSI4[],RSI5[];
//----   
   int limit,to_copy,bar;
//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-StartBar-2; //      
      to_copy=limit+2;
     }
   else //      
     {
      limit=rates_total-prev_calculated;  //       
      to_copy=limit+1;
     }
//----         
   ArraySetAsSeries(RSI1,true);
   ArraySetAsSeries(RSI2,true);
   ArraySetAsSeries(RSI3,true);
   ArraySetAsSeries(RSI4,true);
   ArraySetAsSeries(RSI5,true);
//----      
   if(CopyBuffer(RSI1_Handle,0,0,to_copy,RSI1)<=0) return(0);
   if(CopyBuffer(RSI2_Handle,0,0,to_copy,RSI2)<=0) return(0);
   if(CopyBuffer(RSI3_Handle,0,0,to_copy,RSI3)<=0) return(0);
   if(CopyBuffer(RSI4_Handle,0,0,to_copy,RSI4)<=0) return(0);
   if(CopyBuffer(RSI5_Handle,0,0,to_copy,RSI5)<=0) return(0);
//----    limit        
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      bar=limit+1;
      Osc1 = Factor1 * RSI1[bar];
      Osc2 = Factor2 * RSI2[bar];
      Osc3 = Factor2 * RSI3[bar];
      Osc4 = Factor4 * RSI4[bar];
      Osc5 = Factor5 * RSI5[bar];
      //----
      FastTrend=Osc1+Osc2+Osc3+Osc4+Osc5;
      FastBuffer[bar]=FastBuffer_[bar]=FastTrend;
      SlowBuffer[bar]=SlowBuffer_[bar]=FastTrend/smoothing;
     }
//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      Osc1 = Factor1 * RSI1[bar];
      Osc2 = Factor2 * RSI2[bar];
      Osc3 = Factor2 * RSI3[bar];
      Osc4 = Factor4 * RSI4[bar];
      Osc5 = Factor5 * RSI5[bar];
      //----
      FastTrend = Osc1 + Osc2 + Osc3 + Osc4 + Osc5;
      SlowTrend = FastTrend / smoothing + SlowBuffer[bar + 1] * smoothConst;
      //----
      SlowBuffer[bar]=SlowTrend;
      FastBuffer[bar]=FastTrend;
      //----
      SlowBuffer_[bar]=SlowTrend;
      FastBuffer_[bar]=FastTrend;
     }
//----    
   return(rates_total);
  }
//+------------------------------------------------------------------+
